package mv3302.sensor;

import java.awt.geom.Point2D;
import java.util.Set;
import simkit.SimEntity;
import simkit.smd.Mover;

/**
 *The Sensor interface represents a sensor entity in a simulation. It extends the SimEntity interface.
A sensor can provide information about its current location, velocity, and maximum range.
It can also start and stop moving, retrieve the mover associated with it, and get a set of contacts.
 * @author dansl
 */
interface Sensor extends SimEntity {

    public Point2D getCurrentLocation();
    public Point2D getVelocity();
    public double getMaxRange();
    public void doStartMove(Mover mover);
    public void doStop(Mover mover);
    public Mover getMover();
    public Set<Mover> getContacts();

}
